﻿--[[
DiHook 1.1.5
Date: 2013-09-25T14:18:55Z
Author: cklausi
DiHook.lua
Shows missing dark intent/arcane brilliance/power word: fortitude in the corresponding actionbar tooltip
]]--

local DiScan = {}
local DarkIntent = 109773

local function UnitHasBuff(unit, buff)
	for i=1, 40 do
		local name, _, _, _, _, _, _, _, _ = UnitBuff(unit, i)
		if (name == GetSpellInfo(buff)) then
			return true
		end
	end
	return false
end

local function DiScanner()
	local DiScan = ""
	local party = ""
	local count = 1

	if(UnitInRaid("player")) then
		party = "raid"
		count = 40
	elseif(UnitInParty("player")) then
		party = "party"
		count = 4
	end

	if(party == "raid" or party == "party") then
		for i = 1, count, 1 do
			if 	UnitExists(party..i) and
				not UnitHasBuff(party..i, DarkIntent) and
				not UnitHasBuff(party..i, 1459) and -- Mage
				not UnitHasBuff(party..i, 61316) and -- Mage Dalaran
				not UnitHasBuff(party..i, 126309) and -- Hunterpet
				not UnitHasBuff(party..i, 77747) and -- Shaman
				not UnitHasBuff(party..i, 21562) and -- Priest Stamina
				not UnitHasBuff(party..i, 469) and -- Warrior Stamina
				not UnitHasBuff(party..i, 90364) -- Hunterpet Stamina
			then 
				DiScan = DiScan .. UnitName(party..i) .. " "
			end				
		end
	end
	-- Scan player when not in party or in 5man party
	if(not UnitHasBuff("player", DarkIntent) and 
		(party == "party" or party == "") and
		not UnitHasBuff("player", 1459) and -- Mage
		not UnitHasBuff("player", 61316) and -- Mage Dalaran
		not UnitHasBuff("player", 126309) and -- Hunterpet
		not UnitHasBuff("player", 77747) and -- Shaman
		not UnitHasBuff("player", 21562) and -- Priest Stamina
		not UnitHasBuff("player", 469) and -- Warrior Stamina
		not UnitHasBuff("player", 90364) -- Hunterpet Stamina
	) then 
		DiScan = DiScan .. UnitName("player")
	end
	
	return DiScan
end

local function DiHook(tooltip)
	local _, _, SpellId = tooltip:GetSpell()
	if((SpellId == DarkIntent) or
		SpellId == 1459 or
		SpellId == 61316 or
		SpellId == 21562
	)then
		local DiScan
		DiScan = DiScanner()
		if(#(DiScan) > 0) then 
			tooltip:AddLine(" ", 1, 1, 1)
			tooltip:AddLine("Missing on:", 1, 1, 1)
			tooltip:AddLine(DiScan, 1, 1, 1, 1)
		end
	end
	tooltip:Show()
end

if GameTooltip:GetScript("OnTooltipSetSpell") then
	GameTooltip:HookScript("OnTooltipSetSpell", DiHook)
else
	GameTooltip:SetScript("OnTooltipSetSpell", DiHook)
end 
